/*
 * *** This is an unsupported program; use it at your own risk. ***
 *
 * It is rare that the "oldest message on system" pointer in your message
 * base will become wrong.  If it is wrong, however, one of two situations
 * will exist: for a pointer set too high, messages which are actually on
 * disk will appear to have already scrolled off; for a pointer set too low,
 * an occasional 'cannot locate message' error will be returned for the
 * first few messages on disk.
 * 
 * This program examines the message ID's in your message base, and determines
 * the message ID for the oldest message actually on disk.  It then gives you
 * the opportunity to set the "oldest message on system" pointer to that
 * value.
 *
 * Compile with:
 *   cc fix.c config.o -o fix
 *
 */

#include <stdio.h>
#include <fcntl.h>
#include "citadel.h"

void get_config();	struct config config;

long atol();

int loopgetc(fp)
FILE *fp; {
	if (ftell(fp) > MM_FILELEN) {
		fseek(fp,0L,0);
		printf("WRAP\n");
		}
	return(getc(fp));
	}

fpgetfield(fp,string)	/* level-2 break out next null-terminated string */
FILE *fp;
char string[]; {
	int a,b;

	strcpy(string,"");
	a=0;
	do {
		b=loopgetc(fp);
		if (strlen(string) > 253) return(1);
		if (b<1) { string[a]=0; return(0); }
		string[a]=b;
		string[a+1] = 0;
		++a;
		} while(b!=0);
	return(0);
	}


main() {
	int file,a,b;
	struct msgmain msgmain;
	char bbb[256];
	FILE *fp;
	long mid;
	long extra;
	long old_oldest;

	get_config();

	extra = 0L;

	file=open("MMstructure",O_RDWR);
	read(file,&msgmain,sizeof(struct msgmain));
	old_oldest = msgmain.MMlowest;

	fp=fopen("msgmain","r");
	fseek(fp,msgmain.MMcurpos,0);

TOP:	do {
		b=loopgetc(fp);
		} while(b!=255);
NEX:
	if (loopgetc(fp)==255) goto NEX;
	if (loopgetc(fp)==255) goto NEX;
	mid = 0L;

   	do {
		b=loopgetc(fp);
		if (b==255) goto NEX;
		if ((b!='M')&&(b>0)) fpgetfield(fp,bbb);

		if ((b=='#')&&(mid==0L)) if (atol(bbb)>300000L) mid=atol(bbb);

		} while ((b!='M')&&(b>0));
		printf("# %ld\n",mid);
		if (mid==0L) {
			++extra;
			goto TOP;
			}
		msgmain.MMlowest = mid - extra;

	fclose(fp);
	lseek(file,0L,0);

	if (old_oldest != msgmain.MMlowest) {
		printf("\n%ld messages will be restored to existing status.\n",
			old_oldest - msgmain.MMlowest);
		printf("Set lowest msg pointer to <%ld> ? ",msgmain.MMlowest);
		gets(bbb);
		if (tolower(bbb[0])=='y') 
			write(file,&msgmain,sizeof(struct msgmain));
		close(file);
		}
	else {
		printf("Pointers are already accurate.\n");
		}
	exit(0);
	}
