#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include "citadel.h"

void get_config();	struct config config;

void main() {
	int file;
	struct msgmain msgmain;

	get_config();	
	file=open("./MMstructure",O_RDONLY);
	read(file,&msgmain,sizeof(struct msgmain));
	close(file);

	printf("Node name: %s - Domain name: %s\n",
		config.c_nodename,config.c_fqdn);
	printf("This is %s, located in %s.\n",
		config.c_humannode,config.c_bbs_city);
	printf("The system administrator is %s.\n\n",config.c_sysadm);

if (msgmain.MMflags & MM_VALID)
	printf("New users need validation.\n");
else
	printf("There are no unvalidated users.\n");

	
	printf("\nMessage base statistics:\n");
	printf("Number of messages on system: %ld\n",
		msgmain.MMhighest - msgmain.MMlowest);
	printf("Range of message ID's online: %ld - %ld\n",
		msgmain.MMlowest,msgmain.MMhighest);
	printf("       Current file position: %ld\n",msgmain.MMcurpos);
	printf("        Size of message base: %ld\n",config.c_msgbase);
	printf("      Average message length: %ld\n",
		config.c_msgbase / (msgmain.MMhighest - msgmain.MMlowest));

	exit(0);
	}
